Bug 1476608 - Review Request: ubridge - Bridge for UDP tunnels, Ethernet, TAP and VMnet interfaces
Review Request: ubridge - Bridge for UDP tunnels, Ethernet, TAP and VMnet int...
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jaroslav Škarvada
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-30 13:18 EDT by Athmane Madjoudj
Modified: 2017-10-16 10:10 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jskarvad: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Athmane Madjoudj 2017-07-30 13:18:06 EDT
Spec URL: https://athmane.fedorapeople.org/review/ubridge.spec
SRPM URL: https://athmane.fedorapeople.org/review/ubridge-0.9.12-1.fc26.src.rpm
Description: 
uBridge is a simple application to create user-land bridges between various
technologies. Currently bridging between UDP tunnels, Ethernet and TAP
interfaces is supported. Packet capture is also supported.

Fedora Account System Username: athmane
Comment 1 Athmane Madjoudj 2017-07-30 13:22:06 EDT
NB. This is required by new GNS3.

Rpmlint output:

./SPECS/ubridge.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

./SRPMS/ubridge-0.9.12-1.fc26.src.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

./RPMS/x86_64/ubridge-debuginfo-0.9.12-1.fc26.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

./RPMS/x86_64/ubridge-0.9.12-1.fc26.x86_64.rpm
ubridge.x86_64: W: no-manual-page-for-binary ubridge
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
Comment 2 Jaroslav Škarvada 2017-08-23 08:58:15 EDT
I am mentoring Andrew, he will do the review.
Comment 3 Jaroslav Škarvada 2017-08-28 05:22:34 EDT
(In reply to Jaroslav Škarvada from comment #2)
> I am mentoring Andrew, he will do the review.

There was some misunderstanding, but no problem, I will do the review myself :)
Comment 4 Jaroslav Škarvada 2017-08-29 12:14:25 EDT
===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "LGPL (v2.1 or later)", "GPL (v3 or
     later)", "Unknown or generated". 7 files have unknown license.
     Detailed output of licensecheck in /home/yarda/git-
     fedora/ubridge/1476608-ubridge/licensecheck.txt

I think the package should be licensed under GPLv3+ (according to comments in the sources, I wasn't able to find any other source stating that it should be under GPLv3 only.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.

Package bundles 'iniparser' and part of the 'lxc' (netlink code). Could you unbundle it?

Unbundling 'iniparser' shouldn't be hard. But I am not sure about the 'lxc'. In case it's not easy to unbundle the 'lxc', it will require the 'bundled' keyword.

https://fedoraproject.org/wiki/Packaging:Guidelines#Duplication_of_system_libraries

[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

See bundled libraries above.

[!]: Spec file is legible and written in American English.

There are two spurious whitespaces after 'BuildRequires: libpcap-devel' and after 'BuildRequires: libcap'

[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines

See problems above.

And the package uses capabilities, so I think it should be hardened, see:

https://fedoraproject.org/wiki/Packaging:Guidelines#PIE

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in ubridge-
     debuginfo

False positives

[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.

This is minor problem, but I think it should use 'cp -p' in the Makefile. Well the install time will probably match the compile time in this case, but it's generally better to has there explicitly set the compile time timestamp.

[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ubridge-0.9.12-1.fc25.x86_64.rpm
          ubridge-debuginfo-0.9.12-1.fc25.x86_64.rpm
          ubridge-0.9.12-1.fc25.src.rpm
ubridge.x86_64: W: no-manual-page-for-binary ubridge
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (debuginfo)
-------------------
Checking: ubridge-debuginfo-0.9.12-1.fc25.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
ubridge.x86_64: W: no-manual-page-for-binary ubridge
2 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
ubridge-debuginfo (rpmlib, GLIBC filtered):

ubridge (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpcap.so.1()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
ubridge-debuginfo:
    ubridge-debuginfo
    ubridge-debuginfo(x86-64)

ubridge:
    ubridge
    ubridge(x86-64)



Source checksums
----------------
https://github.com/GNS3/ubridge/archive/v0.9.12/ubridge-0.9.12.tar.gz :
  CHECKSUM(SHA256) this package     : 44b8584dad54e342ef2f1d47a6483dfb445bd911f7b07e2235645034b5ee5532
  CHECKSUM(SHA256) upstream package : 44b8584dad54e342ef2f1d47a6483dfb445bd911f7b07e2235645034b5ee5532


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1476608
Buildroot used: fedora-25-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 5 Athmane Madjoudj 2017-08-29 18:15:17 EDT
Thank you for reviewing, please let me know if you need to review other package in exchange.

I've unbundled iniparse (patch submitted upstream), fixed the spaces and license.
lxc netlink code is from older lxc codebase which is not provided by Fedora (there's newer release), so i added requirement with bundled prefix.

If recall correctly, hardened build is now enabled by default, you can check with: 

[athmane@devel2 ~]$ cat /etc/fedora-release 
Fedora release 26 (Twenty Six)
[athmane@devel2 ~]$ rpm --eval '%{_hardened_build}'
1

New SPEC/SRPM:

Spec URL: https://athmane.fedorapeople.org/review/ubridge.spec
SRPM URL: https://athmane.fedorapeople.org/review/ubridge-0.9.12-2.fc26.src.rpm
Comment 6 Jaroslav Škarvada 2017-09-03 07:07:31 EDT
It seems OK, giving fedora_review+.

I have opened bug 1471175, it's not important and not in a hurry. I don't care about the swap, just in case if you are interested.
Comment 7 Jaroslav Škarvada 2017-09-03 07:09:01 EDT
(In reply to Jaroslav Škarvada from comment #6)
> It seems OK, giving fedora_review+.
> 
> I have opened bug 1471175, it's not important and not in a hurry. I don't
> care about the swap, just in case if you are interested.

I meant linked bug 1481645 :)
Comment 8 Gwyn Ciesla 2017-10-16 10:10:15 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ubridge

Note You need to log in before you can comment on or make changes to this bug.